<template>
    <div class="gdpr-modal" v-if="isVisible">
        <div class="gdpr-modal__dialog">
            <div class="gdpr-modal__content">
                <div class="gdpr-modal__header" v-if="title">
                    <div class="gdpr-modal__title" v-html="title"></div>
                </div>
                <div class="gdpr-modal__body">
                    <div class="gdpr-modal__content" v-if="content">
                        <div v-html="content"></div>
                    </div>
                    <div class="gdpr-modal__level" v-for="(value, key) in computedLevels" :key="key">
                        <div class="gdpr-modal__title" v-html="value.title"></div>
                        <div class="gdpr-modal__content">
                            <div v-html="value.content"></div>
                        </div>
                        <div class="gdpr-modal__check">
                            <div :class="['gdpr__toggle', {active: isChecked(key), disabled: isDisabled(key)}]">
                                <input type="checkbox" name="level" :id="`gdpr-input-${key}`"
                                       :disabled="isDisabled(key)" :checked="isChecked(key)"
                                       v-model="checked[key]">
                                <label :for="`gdpr-input-${key}`">{{ isChecked(key) ? labelActive : labelInactive }}</label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="gdpr-modal__footer">
                    <button class="gdpr-btn gdpr-modal__agreement" type="button" @click="onClickAgreement">
                        {{ buttonAgreement }}
                    </button>
                </div>
                <button class="gdpr-modal__close" type="button" @click="close">
                    {{ buttonClose }}
                </button>
            </div>
        </div>
        <div class="gdpr-modal__backdrop" @click="close"></div>
    </div>
</template>

<script>
export default {
    name: 'gdpr-modal',
    props: {
        buttonAgreement: {
            default: 'Agreement',
            required: true,
            type: String,
        },
        buttonClose: {
            default: 'Close',
            required: true,
            type: String,
        },
        content: {
            default: 'You can find out more about which cookies we use, or switch them off. Here, you\'ll also find links to our [policy]Cookie Policies[/policy], which explain how we process your personal data.',
            required: true,
            type: String,
        },
        labelActive: {
            default: 'Enabled',
            type: String,
        },
        labelInactive: {
            default: 'Disabled',
            type: String,
        },
        levels: {
            default() {
                return null;
            },
            type: Object,
        },
        title: {
            default: 'Cookie settings',
            type: String,
        },
    },
    data() {
        return {
            isVisible: false,
            checked: {},
        };
    },
    computed: {
        computedLevels() {
            if (this.levels) {
                return this.levels;
            }

            return this.$gdpr.levels;
        },
    },
    watch: {
        isVisible(value) {
            const body = document.body;

            this.removeEventListener();

            if (value) {
                body.classList.add('gdpr_modal-opened');
            } else {
                body.classList.remove('gdpr_modal-opened');
            }

            setTimeout(() => this.addEventListener());
        },
    },
    methods: {
        /**
         * Add listener to close modal on press ESCAPE key.
         */
        addEventListener() {
            document.addEventListener('keyup', (e) => this.onEscapeClose(e));
        },

        /**
         * Close modal.
         */
        close() {
            this.isVisible = false;
        },

        /**
         * Determine if the given level is checked.
         * @param level
         * @return {boolean|*}
         */
        isChecked(level) {
            if (level === 'required') {
                return true;
            }

            return this.checked[level];
        },

        /**
         * Disable default level (= required).
         * @param key
         * @return {boolean}
         */
        isDisabled(key) {
            return key === 'required';
        },

        /**
         * When clicking "agree", set the cookie, close the bar and close the modal.
         */
        onClickAgreement() {
            const selected = Object.entries(this.checked).filter(([key, value]) => value).reduce((acc, [key, value]) => {
                acc = key;
                return acc;
            }, '');

            this.$gdpr.setLevel(selected);
            this.$root.$emit('gdpr_bar:close');
            this.close();
        },

        /**
         * Event handler for the ESCAPE key listener.
         * @param e
         */
        onEscapeClose(e) {
            if (e.code === 'Escape' || e.keyCode === 27) {
                this.close();
            }
        },

        /**
         * Open modal.
         */
        open() {
            this.isVisible = true;
        },

        /**
         * Remove listener on ESCAPE key.
         */
        removeEventListener() {
            document.removeEventListener('keyup', (e) => this.onEscapeClose(e));
        },
    },
    mounted() {
        // fill zero state checked (required is always checked)
        if (this.computedLevels) {
            this.checked = Object.keys(this.computedLevels).reduce((acc, value) => {
                acc[value] = this.$gdpr.getLevel() === null || value === 'required' || value === this.$gdpr.getLevel();
                return acc;
            }, {});
        }

        // allow to open modal from every where
        this.$root.$on('gdpr_modal:open', () => {
            this.open();
        });

        if (this.$gdpr.isModalVisible) {
            this.open();
        }
    },
};
</script>

<style lang="scss">
:root {
    --gdpr-background: black;
    --gdpr-color: white;
    --gdpr-zindex: 1100;
    --gdpr-active: #a9cc8d;
    --gdpr-active-color: #fff;
    --gdpr-inactive: #e88388;
    --gdpr-inactive-color: #fff;
}

body.gdpr_modal-opened {
    overflow: hidden;
}

.gdpr-modal__close {
    background: transparent;
    border: none;
    display: block;
    height: 25px;
    opacity: .4;
    overflow: hidden;
    padding: 0;
    position: absolute;
    right: -30px;
    text-indent: -999px;
    top: 0;
    width: 25px;

    &:hover {
        opacity: 1;
    }

    &::before, &::after {
        background-color: white;
        background-color: var(--gdpr-color);
        content: '';
        height: 25px;
        left: 10px;
        position: absolute;
        top: 0;
        width: 5px;
    }

    &::before {
        transform: rotate(45deg);
    }

    &::after {
        transform: rotate(-45deg);
    }
}

.gdpr-modal__agreement {
    background-color: #a9cc8d;
    background-color: var(--gdpr-active);
    border-color: #a9cc8d;
    border-color: var(--gdpr-active);
    color: #fff;
    color: var(--gdpr-active-color);
    padding: .375rem .75rem;

    &:focus, &:hover {
        background-color: #fff;
        background-color: var(--gdpr-active-color);
        color: #a9cc8d;
    }
}

.gdpr-modal {
    bottom: 0;
    left: 0;
    line-height: 1.4em;
    position: fixed;
    right: 0;
    top: 0;
    z-index: calc(1100 + 50);
    z-index: calc(var(--gdpr-zindex) + 50);

    @media (max-width: 575.98px) {
        font-size: .8em;
        line-height: 1.2em;
    }
    @media (min-width: 576px) {
        font-size: .9em;
    }
    @media (min-width: 768px) {}
    @media (min-width: 992px) {}
    @media (min-width: 1200px) {}

    &__dialog {
        margin: 1.75rem 2.5em 1.75rem 1em;
        position: relative;

        @media (max-width: 575.98px) {}
        @media (min-width: 576px) {
            margin: 1.75rem auto;
            max-width: 400px;
        }
        @media (min-width: 768px) {
            max-width: 600px;
            width: 80vw;
        }
        @media (min-width: 992px) {
            max-width: 800px;
        }
        @media (min-width: 1200px) {
            max-width: 1000px;
        }
    }

    &__content {
        background-clip: padding-box;
        background-color: white;
        background-color: var(--gdpr-color);
        color: black;
        color: var(--gdpr-background);
        display: flex;
        flex-direction: column;
        outline: 0;
        position: relative;

        @media (max-width: 575.98px) {}
        @media (min-width: 576px) {}
        @media (min-width: 768px) {
            .gdpr-modal__header {
                margin: 40px 50px 10px 50px;
            }
            .gdpr-modal__body {
                margin: 10px 50px;
            }
            .gdpr-modal__footer {
                margin: 10px 50px 40px;
            }
        }
        @media (min-width: 992px) {}
        @media (min-width: 1200px) {}

        .gdpr-modal__title {
            font-size: 2em;
            font-weight: bold;
        }

        .gdpr-modal__content {}

        .gdpr-modal__header {
            margin: 30px 25px 10px 25px;
        }
        .gdpr-modal__body {
            margin: 10px 25px;
        }
        .gdpr-modal__footer {
            margin: 10px 25px 30px;
        }

        .gdpr-modal__level {
            position: relative;

            @media (max-width: 575.98px) {}
            @media (min-width: 576px) {}
            @media (min-width: 768px) {
                padding-right: 180px;

                .gdpr-modal__check {
                    position: absolute;
                    right: 0;
                    top: 0;
                }
            }
            @media (min-width: 992px) {}
            @media (min-width: 1200px) {}

            .gdpr-modal__title {
                font-size: 1.2em;
                margin-bottom: 10px;
            }

            .gdpr-modal__content {}

            .gdpr-modal__check {
                text-align: right;
            }
        }
    }

    &__backdrop {
        background-color: black;
        background-color: var(--gdpr-background);
        bottom: 0;
        left: 0;
        opacity: .9;
        position: fixed;
        right: 0;
        top: 0;
        z-index: -1;
    }
}

// @todo Make a mixin like checkbox-variant()
.gdpr__toggle {
    color: #e88388;
    color: var(--gdpr-inactive);
    display: inline-block;
    min-height: 1.5rem;

    &.active {
        color: #a9cc8d;
        color: var(--gdpr-active);
    }

    &.disabled {
        opacity: .6;
    }

    input[type="checkbox"] {
        cursor: pointer;
        opacity: 0;
        position: absolute;

        + label {
            cursor: pointer;
            height: 1.5rem;
            line-height: 1.5rem;
            padding-right: 4.5rem;
            position: relative;

            &:after {
                background-color: white;
                background-color: var(--gdpr-color);
                border-color: #e88388;
                border: 1px solid var(--gdpr-inactive);
                border-radius: 500rem;
                content: '';
                cursor: pointer;
                height: 1.5rem;
                opacity: 1;
                position: absolute;
                right: 2.05rem;
                top: 0;
                transition: background .3s ease 0s, right .3s ease 0s;
                width: 1.5rem;
                z-index: 2;
            }

            &:before {
                background-color: #e88388;
                background-color: var(--gdpr-inactive);
                border: none;
                border-radius: 500rem;
                content: '';
                cursor: pointer;
                display: block;
                height: 1.5rem;
                position: absolute;
                right: 0;
                top: 0;
                width: 3.5rem;
                z-index: 1;
            }
        }

        &:checked {
            + label {
                &:after {
                    border-color: #a9cc8d;
                    border-color: var(--gdpr-active);
                    content: '';
                    right: 0;
                }

                &:before {
                    background-color: #a9cc8d;
                    background-color: var(--gdpr-active);
                }
            }
        }

        &:disabled {
            + label {
                &:after {
                    border-color: #a9cc8d;
                    border-color: var(--gdpr-active);
                    cursor: not-allowed;
                }
                &:before {
                    background-color: #a9cc8d;
                    background-color: var(--gdpr-active);
                    cursor: not-allowed;
                }
            }
        }
    }
}
</style>
